﻿using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System;

namespace Post
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void Map1_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;
            Map1.CurrentExtent = new RectangleShape(-130, 90, 130, -90);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"C:\TG-ChenHao\Development\WpfDesktopEdition\HowDoISamples\CSharp Samples\SampleData\Data\Countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay worldOverlay = new LayerOverlay();
            worldOverlay.Layers.Add("WorldLayer", worldLayer);
            Map1.Overlays.Add("WorldOverlay", worldOverlay);

            InMemoryFeatureLayer highlightLayer = new InMemoryFeatureLayer();
            highlightLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Evergreen1;
            highlightLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay highlightOverlay = new LayerOverlay();
            highlightOverlay.Layers.Add("HighlightLayer", highlightLayer);
            highlightOverlay.TileType = TileType.SingleTile;
            Map1.Overlays.Add("HighlightOverlay", highlightOverlay);

            SelectExtentInteractiveOverlay selectExtentInteractiveOverlay = new SelectExtentInteractiveOverlay(worldLayer);
            selectExtentInteractiveOverlay.Selected += new EventHandler<SelectedSelectExtentInteractiveOverlayEventArgs>(selectExtentInteractiveOverlay_Selected);
            Map1.ExtentOverlay = selectExtentInteractiveOverlay;

            Map1.Refresh();
        }

        private void selectExtentInteractiveOverlay_Selected(object sender, SelectedSelectExtentInteractiveOverlayEventArgs e)
        {
            LayerOverlay highlightOverlay = (LayerOverlay)Map1.Overlays["HighlightOverlay"];
            InMemoryFeatureLayer highlightLayer = (InMemoryFeatureLayer)highlightOverlay.Layers["HighlightLayer"];

            highlightLayer.InternalFeatures.Clear();
            foreach (Feature feature in e.SelectedFeatures)
            {
                highlightLayer.InternalFeatures.Add(feature);
            }

            highlightOverlay.Refresh();
        }
    }
}
